from picamera2 import Picamera2, Preview
import RPi.GPIO as GPIO
from smbus2 import SMBus
from datetime import datetime
import time,threading,math,os
flash,sw,photoi,valve = 12,4,5,18 #GPIO
mcp3425 = 0x68 #Device-ID
global dtime , delaytime
path = '/home/pi/data/'

bus = SMBus(1)
picam2 = Picamera2()
picam2.configure('still')
picam2.start()
picam2.set_controls({'AeEnable': False, 'AwbEnable': True, 'FrameRate': 1.0})
GPIO.setmode(GPIO.BCM)
GPIO.setup(flash,GPIO.OUT)
GPIO.setup(photoi,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(sw,GPIO.IN,pull_up_down=GPIO.PUD_UP)
GPIO.setup(valve, GPIO.OUT)

def drip(gpio_pin):
    GPIO.output(valve, 0)
    time.sleep(0.03)
    GPIO.output(valve, 1)
    
def event(gpio_no):
    time_flash = threading.Timer(dtime,flashing)
    time_flash.start()
    time_flash.join()

def flashing():
    GPIO.output(flash,1)
    time.sleep(0.0001)
    GPIO.output(flash,0)
        
GPIO.add_event_detect(photoi,GPIO.FALLING,callback=event,bouncetime=300)
GPIO.output(valve, 1)
delaytime =180
dtime = delaytime/1000

while True:
    if GPIO.input(sw)==0:
        for i in range(0,100,5):
            delaytime =200+i
            dtime = delaytime/1000
            drip(sw)
            r = picam2.capture_request()
            r.save('main', '/home/pi/image.jpg')
            r.release()
            timestamp = datetime.now().isoformat()+'_'+str(delaytime)+'.jpg'
            os.rename('/home/pi/image.jpg',path+timestamp)
    else:
        event(photoi)
        r = picam2.capture_request()
        r.release() 